﻿@model IEnumerable<ExploreApilkasiCuti.Models.PengajuanCuti>

@{
    ViewBag.Title = "Pengajuan Cuti";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<style>
    .content-table {
        border-collapse: collapse;
        margin: 25px 0;
        min-width: 1000px;
        box-shadow: 0 0 20px rgba(0, 0, 0, 0.15);
        width: 100%;
    }

    /* if the browser window is at least 800px-s wide: */
    @@media screen and (min-width: 800px) {
        table {
            width: 90%;
        }
    }

    /* if the browser window is at least 1000px-s wide: */
    @@media screen and (min-width: 1000px) {
        table {
            width: 80%;
        }
    }

    .content-table thead tr {
        background-color: #10ad21;
        color: #ffffff;
        text-align: left;
    }

    .content-table tr, td {
        border: solid black 0.5px;
    }

    .content-table th, td {
        padding: 12px 10px;
        border: solid black 0.5px;
    }

    #dataMasterJabatan_filter .iconSearch {
        float: left;
        display: inline-block;
    }

    .help-block {
        color: red;
    }

    .has-error {
        color: red;
    }

    .grid {
        display: grid;
        grid-column-gap: 1rem;
        grid-auto-flow: column;
        margin: 0 0 0 0;
    }
</style>

@section HeadLibrary{
    <meta name="description" content="Select2 is a jQuery based replacement for select boxes. It supports searching, remote data sets, and pagination (infinite scrolling) of results.">
    <link rel="stylesheet" href="~/AdminLTE/plugins/fontawesome-free/css/all.min.css">
    <!-- Ionicons -->
    <link rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
    <!-- DataTables -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="~/AdminLTE/plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
    <!-- Toast-->
    <link rel="stylesheet" href="~/AdminLTE/plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css" />
    <link rel="stylesheet" href="~/AdminLTE/plugins/toastr/toastr.min.css" />
    <!-- Theme style -->
    <link rel="stylesheet" href="~/AdminLTE/dist/css/adminlte.min.css">
    <!-- Google Font: Source Sans Pro -->
    @*    <link href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700" rel="stylesheet">
    *@    <!-- Select2 -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2/css/select2.min.css">
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
    <!-- Datepicker-->
    <link rel="stylesheet" href="~/AdminLTE/plugins/bootstrap-datepicker/css/bootstrap-datepicker.min.css">
}

<div class="card" id="cardPengajuanHeader">
    <div class="card-header">
        <h3 class="card-title"> Daftar Pengajuan Cuti</h3>
    </div>
    <div class="card-body">
        <div>
            <div class="row">
                <button type="button" class="btn btn-success" onclick="go_to_detail()" id="btnGoToDtl">
                    <i class="fa fa-plus-circle fa"></i>   Tambah Data
                </button>
                <div class="mt-3 col-md-12"></div>
            </div>
            <div class="row">
                <div class="col-sm-12">
                    <table id="dataListPengajuanCuti" class="table table-bordered table-striped" style="color:black">
                        <thead>
                            <tr>
                                @*<th>
                                    No.
                                </th>*@
                                <th>
                                    ID Pengajuan
                                </th>
                                <th>
                                    Tanggal Pengajuan
                                </th>
                                <th>
                                    Nama Karyawan
                                </th>
                                <th>
                                    Jenis Cuti
                                </th>
                                <th>
                                    Lama Cuti
                                </th>
                                <th>
                                    Alamat
                                </th>
                                <th>
                                    No. Telp.
                                </th>
                                <th>
                                    Status Approval
                                </th>
                                <th>
                                    Keterangan Approval
                                </th>
                                <th style="width:65px">
                                    Action
                                </th>
                            </tr>
                        </thead>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>

<div class="card" id="cardPengajuanDetail">
    <div class="card-header">
        <h2 id="headerAddSeeDtl">Tambah Pengajuan Cuti</h2>
    </div>
    <div class="card-body">
        <div class="row justify-content-between">
            @*<a href="@Url.Action("Index", "PengajuanCuti")" class="btn btn-default">
                    <i class="nav-icon fas fa-chevron-left"></i>   Kembali
                </a>*@
            <button type="button" class="btn btn-default" onclick="back_to_header()" id="btnBackToHeader">
                <i class="nav-icon fas fa-chevron-left"></i>   Kembali
            </button>
            <div class="mt-3 col-md-12"></div>
        </div>
        <div class="card card-primary card-outline card-outline-tabs">
            <div class="card-body">
                <!--<div class="card card-primary">-->
                <form role="form" id="form-header">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-12 col-sm-6">
                                <div class="form-group">
                                    <label class="err-jenisCuti control-label">Jenis Cuti</label>
                                    <select name="JenisCuti" id="JenisCuti" class="form-control select2 select2-hidden-accessible JenisCuti" style="width: 100%;">
                                    </select>
                                    <span id="spanJenisCuti" class="err-jenisCuti help-block"></span>
                                </div>
                                <div class="form-group">
                                    <div class="row">
                                        <div class="col-12 col-sm-6">
                                            <label class="control-label" style="padding-right:1em" id="labelDatepicker">Pilih Tanggal Cuti</label>
                                            <div class="input-group date form-group" id="datepicker">
                                                <input type="text" class="form-control" id="LeaveDatePicker" name="LeaveDatePicker" placeholder="Select days" hidden />
                                                @*<span class="input-group-addon"><i class="fa fa-calendar"></i><span class="count"></span></span>*@
                                                <span class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-secondary waves-effect waves-light"><i class="fa fa-calendar"></i></span>
                                                <span id="span_tanggal" class="help-block"></span>
                                            </div>
                                        </div>
                                        <div class="col-12 col-sm-6">
                                            <label class="control-label" id="totalDurasi" style="padding-right:1em">Total Durasi</label>
                                            <input class="form-control" id="totalDurasiInput" type="text" readonly>
                                        </div>
                                        <span id="span_leave_half_day" class="help-block"></span>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="control-label">Keterangan</label>
                                    <textarea name="Keterangan" placeholder="Enter ..." id="Keterangan" class="form-control" type="text" rows="3"></textarea>
                                    <span class="help-block"></span>
                                </div>
                                <div class="form-group">
                                    <label class="control-label">Alamat Saat Cuti</label>
                                    <textarea name="AlmSaatCuti" placeholder="Enter ..." id="AlmSaatCuti" class="form-control" type="text" rows="3"></textarea>
                                    <span class="help-block"></span>
                                </div>
                                <div class="form-group">
                                    <label class="control-label">Telp. Saat Cuti</label>
                                    <input name="TelpSaatCuti" placeholder="No. Telepon" id="TelpSaatCuti" class="form-control" type="number">
                                    <span class="help-block"></span>
                                </div>
                                <div class="form-group" id="sendToApproval">
                                    <label class="control-label">Kirim Ke</label>
                                    <div class="grid" style="width:100%" id="gridSendToApproval">
                                        <div class="form-group" style="width:100%">
                                            @*<label class="err-idApproval control-label">ID Approval</label>*@
                                            <select name="IDApproval" id="IDApproval" class="form-control select2 IDApproval" style="width: 100%;">
                                            </select>
                                            <span id="spanIdApproval" class="err-idApproval help-block"></span>
                                        </div>
                                        <div class="form-group" style="width:100%">
                                            @*<label class="err-idKywApproval control-label">ID Karyawan Approval</label>*@
                                            <select name="IDKywApproval" id="IDKywApproval" class="form-control select2 IDKywApproval" style="width: 100%;">
                                            </select>
                                            <span id="spanIdKywApproval" class="err-idKywApproval help-block"></span>
                                        </div>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label for="customFile" class="control-label" id="labelUploadFile">Attachment</label>
                                    <div class="row">
                                        <div class="custom-file col-12 col-sm-10">
                                            <input type="file" class="custom-file-input" id="file" name="file">
                                            <label class="custom-file-label " for="customFile">Pilih File</label>
                                        </div>
                                        <div class="col-12 col-sm-2">
                                            <button type="button" class="btn btn-default" onclick="RemoveFile()" id="btnRemovefile">
                                                <i class="nav-icon fas fa-times-circle"></i>
                                            </button>
                                        </div>
                                    </div>
                                    <span class="help-block" id="spanfile"></span>
                                </div>
                                <div class="form-group" id="saveFile">
                                        <label class="control-label">Attachment</label>
                                        <div></div>
                                        <input name="nama_file" placeholder="Tidak Ada" id="nama_file" type="text" style="width:300px" disabled>
                                        <button type="button" class="btn btn-default" onclick="saveFile()" id="btnSaveFile">
                                            <i class="nav-icon fas fa-save"></i>   Download
                                        </button>
                                </div>
                            </div>
                            <div class="col-12 col-sm-6">
                                <div class="form-group" id="approvalDetail">
                                    <label class="control-label">History Approval</label>
                                    <!-- The timeline -->
                                    <div class="timeline timeline-inverse" id="historyApproval">
                                    </div>
                                </div>
                            </div>
                            <!--<label class="col-md-12" style="color:red">*Klik Tab untuk pindah field.</label>-->
                        </div>
                    </div>
                </form>
                <!--</div>-->
            </div>
            <div class="card-footer">
                <button type="button" class="btn btn-default" onclick="add_update_data('ADD')" id="btnSubmitData">
                    <i class="nav-icon fas fa-save"></i>   Submit Data
                </button>
            </div>
        </div>
    </div>
</div>

<div aria-live="polite" aria-atomic="true" style="position: relative; min-height: 200px;">
    <!-- Then put toasts within -->
    <div id="toastResult" class="toast" style="position: absolute; top: 0; right: 0;">
        <div class="toast-header">
            <i class="fa fa-check"></i>
            <strong class="mr-auto">Success</strong>
            <button type="button" class="ml-2 mb-1 close" data-dismiss="toast" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
        <div class="toast-body">
            <h6 class="toast-body-header">Master Jabatan berhasil update.</h6>
        </div>
    </div>
</div>

@section BodyLibrary{
    <!-- DataTables -->
    <script src="@Url.Content("~/AdminLTE/plugins/datatables/jquery.dataTables.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/dataTables.responsive.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/responsive.bootstrap4.min.js")"></script>
    <!-- SweetAlert2 -->
    <script src="@Url.Content("~/AdminLTE/plugins/sweetalert2/sweetalert2.min.js")"></script>
    <!-- Toastr -->
    <script src="@Url.Content("~/AdminLTE/plugins/toastr/toastr.min.js")"></script>
    <!-- DataRender -->
    <script src="@Url.Content("~/AdminLTE/plugins/dataRender/dateTime.js")"></script>
    <!-- Select2 -->
    <script src="@Url.Content("~/AdminLTE/plugins/select2/js/select2.full.min.js")"></script>
    <!-- Datepicker -->
    <script src="~/AdminLTE/plugins/bootstrap-datepicker/js/bootstrap-datepicker.min.js"></script>
    <!-- Select2 -->
    <script src="~/AdminLTE/plugins/select2/js/select2.full.min.js"></script>
}

@section AdditionalScript{
    <script type="text/javascript">
        var pengajuanCutiTable;
        var destination = '@ViewBag.Action';
        var tempId = '@Session["id_karyawan"]';
        var masterPengajuanDetailTable;
        var listDataDtl = [];
        var listDateCollection = [];
        var tglPengajuan = "";
        var GroupID = '@Session["AccountGroupName"]';
        var dateToday = new Date();
        var id_Pengajuan = "";
        var filesize = "";
        var detailLinkFile = "";
        jQuery(document).ready(function ($) {
            $(function () {
                $("#file").change(function () {
                    checkfile();
                });
            });
            bsCustomFileInput.init();

            $("#cardPengajuanHeader").show();
            $("#cardPengajuanDetail").hide();
            loadDataSelect2();
            unselect_select2();
            pengajuanCutiTable = $("#dataListPengajuanCuti").DataTable({
                "responsive": true,
                "autoWidth": false,
                "ajax": {
                    "datatype": 'json',
                    "url": '@Url.Action("LoadDataPengajuanCuti")',
                    "type": 'POST',
                },
                "columns": [
                    //{ "data": "no_urut", "name": "no_urut" },
                    { "data": "id_pengajuan", "name": "id_pengajuan" },
                    { "data": "tgl_pengajuan", "name": "tgl_pengajuan" },
                    { "data": "nama", "name": "nama"},
                    { "data": "id_jenis_pengajuan", "name": "id_jenis_pengajuan" },
                    { "data": "durasi", "name": "durasi" },
                    { "data": "alamat_cuti", "name": "alamat_cuti" },
                    { "data": "notelp_cuti", "name": "notelp_cuti" },
                    { "data": "approve_status", "name": "approve_status" },
                    { "data": "keterangan_approve", "name": "keterangan_approve", "autoWitdh": true },
                   // { "data": "created_by", "name": "created_by" },
                   // { "data": "created_date", "name": "created_date" },
                   // { "data": "changed_by", "name": "changed_by" },
                   // { "data": "changed_date", "name": "changed_by" },
                    { "data": "action" },
                ]
            });

        });

        function edit_pengajuan(rowId) {
            @*var url = '@Url.Action("PengajuanCutiPages", "PengajuanCuti", new { id = "rowId", destination = "Edit",})';//new { id = "rowId", action = "action" })';
            window.location.href = url.replace('rowId', rowId);*@
            $("#cardPengajuanHeader").hide();
            $("#cardPengajuanDetail").show(100);
            $("#headerAddSeeDtl").text("Detail Pengajuan No. " + rowId);
            loadDataDetailbyIdPengajuan("Edit", rowId);
        }

        function detail_pengajuan(rowId) {
            @*var url = '@Url.Action("PengajuanCutiPages", "PengajuanCuti", new { id = "rowId", destination = "Detail"})';//new { id = "rowId", action = "action" })';
            window.location.href = url.replace('rowId', rowId);*@
            $("#cardPengajuanHeader").hide();
            $("#cardPengajuanDetail").show(100);
            $("#headerAddSeeDtl").text("Detail Pengajuan No. " + rowId);
            loadDataDetailbyIdPengajuan("Detail", rowId);
        }

        function back_to_header() {
            $("#cardPengajuanHeader").show(100);
            $("#cardPengajuanDetail").hide();
        }

        function go_to_detail() {
            $("#cardPengajuanHeader").hide();
            $("#cardPengajuanDetail").show(100);
            $("#headerAddSeeDtl").text("Tambah Pengajuan Cuti");
            loadDataDetailbyIdPengajuan("Add", "");
            listDataDtl = [];
            listDateCollection = [];
        }

        function loadDataDetailbyIdPengajuan(destination, rowId) {
            listDataDtl = [];
            listDateCollection = [];
            $("#datepicker").datepicker('destroy');
            $("#historyApproval").empty();
            detailLinkFile = "";
            jQuery(document).ready(function ($) {
            if (destination == 'Edit' || destination == 'Detail') {
                $("#saveFile").show(); 
                $(".card-footer").hide();
                $(".custom-file").hide(); 
                $("#btnRemovefile").hide(); 
                $("#labelUploadFile").hide();
                $("#removefile").hide();
                $("#sendToApproval").hide();
                $("#approvalDetail").show();
                $.ajax({
                    contentType: 'application/JSON; charset=utf-8',
                    url: '@Url.Action("GetDataDetailPengajuan", "PengajuanCuti")',
                    type: 'POST',
                    data: JSON.stringify({ "id": rowId }),
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Processing...',
                            html: "Get Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (data) {
                        Swal.close();
                        if (data.response.Code == '200') {
                            successInitData(data['data'], "Detail");
                            //if (destination == "Edit") loadDataSelect2();
                        } else {
                            toastr.warning('Gagal memuat data', 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        toastr.error('Gagal memuat data', 'Failed!', { "timeOut": 5000 });
                    }
                });
            } else {
                resetTextInputValue();
                $("#saveFile").hide(); 
                $(".custom-file").show(); 
                $("#btnRemovefile").show(); 
                $(".card-footer").show();
                $("#sendToApproval").show();
                $("#approvalDetail").hide();
                enableDisableTextInput(false);
                loadDataSelect2();
                unselect_select2();
                setTanggalPengajuan();

            }
        });
       }

        function successInitData(data, destination) {
            tglPengajuan = data[0].tgl_pengajuan;
            detailLinkFile = data[0].link_file;
           
            $("#totalDurasiInput").val(data[0].durasi + " hari");
            $("#Keterangan").val(data[0].keterangan_pengajuan);
            $("#AlmSaatCuti").val(data[0].alamat_cuti);
            $("#TelpSaatCuti").val(data[0].notelp_cuti);
            $("#labelDatepicker").text("Lihat Tanggal Cuti");
            $("#JenisCuti").empty().append($("<option/>").val(data[0].id_jenis_pengajuan).text(data[0].nama_pengajuan)).val(data[0].id_jenis_pengajuan);;
            $("#IDApproval").empty().append($("<option/>").val(data[0].id_approval).text(data[0].nama_approval)).val(data[0].id_approval);
            $("#IDKywApproval").empty().append($("<option/>").val(data[0].approved_by).text(data[0].nama_karyawan_approval)).val(data[0].approved_by);
            $("#nama_file").val(data[0].nama_file);
            if ($("#nama_file").val() == '') {
                $("#btnSaveFile").prop('disabled', true);
            }

            listDataDtl = data[0].details;
            for (var i = 0; i < listDataDtl.length; i++) {
                listDateCollection.push(listDataDtl[i].start_date.replace("T00:00:00", ""));
            }

            //$(document).ready(function () {
            $('#datepicker').datepicker({
                multidate: true,
                format: "mm/dd/yyyy",
                todayHighlight: true,
                beforeShowDay: function () {
                    return false;
                }
            });

            $("#datepicker").datepicker('setDates', listDateCollection);
            $('#datepicker').datepicker('setStartDate', new Date());
            //});

            if (destination == 'Edit') {
                enableDisableTextInput(false);

            } else if (destination == 'Detail') {
                enableDisableTextInput(true);
            }

            loadDataLogApprovalElm(data[0].id_pengajuan);
        }

        function resetTextInputValue() {
            $("#totalDurasiInput").val("");
            $("#JenisCuti").val("").text("");
            $("#LamaCuti").val("");
            $("#Keterangan").val("");
            $("#AlmSaatCuti").val("");
            $("#TelpSaatCuti").val("");
            $("#IDApproval").val("").text("");
            $("#IDKywApproval").val("").text("");
        }

        function enableDisableTextInput(enables) {
            $("#JenisCuti").prop('disabled', enables);
            $("#LamaCuti").attr('readonly', enables);
            $("#Keterangan").attr('readonly', enables);
            $("#AlmSaatCuti").attr('readonly', enables);
            $("#TelpSaatCuti").attr('readonly', enables);
            $("#IDApproval").prop('disabled', enables);
            $("#IDKywApproval").prop('disabled', enables);
        }

        function loadDataLogApprovalElm(rowId) {
            $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Action("GetSpecificDataLogAppReturnElm", "MasterLogApproval")',
                type: 'POST',
                data: JSON.stringify({ "idPengajuan": rowId }),
                success: function (data) {
                    if (data.response.Code == '200') {
                        $("#historyApproval").append(data['data']);
                    } else {
                        toastr.warning('Gagal memuat data History Approval', 'Sorry!', { 'timeOut': 5000 });
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    toastr.error('Gagal memuat data', 'Failed!', { "timeOut": 5000 });
                }
            });
        }

        function loadDataDetailTable(destination) {
            if (destination == "Detail") {
                if (!$.fn.DataTable.isDataTable('#dataPengajuanCutiDetail')) {
                    jQuery(document).ready(function ($) {
                        masterPengajuanDetailTable = $("#dataPengajuanCutiDetail").DataTable({
                            "autoWidth": false,
                            "responsive": true,
                            "ajax": {
                                "datatype": 'json',
                                "url": '@Url.Action("GetDataDetailPengajuanById", "PengajuanCuti")/' + '@ViewBag.Id' + '?destination=' + destination,//, new { id = @ViewBag.Id, destination = "Detail" })',
                                "type": 'POST',
                        @*"data": JSON.stringify({"id": '@ViewBag.Id'})*@
                            },
                            "columns": [
                                { "data": "id_pengajuan_detail", "name": "id_pengajuan_detail", "visible": false },
                                { "data": "no", "name": "no" },
                                { "data": "start_date", "name": "start_date" },
                                { "data": "end_date", "name": "end_date" },
                                { "data": "durasi", "name": "durasi" },
                                { "data": "action" },
                            ]
                        });
                    });
                }
                masterPengajuanDetailTable?.column([0]).visible(false, false);
                masterPengajuanDetailTable?.columns.adjust().draw(false);
            } else {
                if (!$.fn.DataTable.isDataTable('#dataPengajuanCutiDetail')) {
                    jQuery(document).ready(function ($) {
                        masterPengajuanDetailTable = $("#dataPengajuanCutiDetail").DataTable({
                            "autoWidth": false,
                            "responsive": true,
                            "data": listDataDtl,
                            "columns": [
                                { "data": "IdPengajuan", "name": "id_pengajuan_detail", "visible": false, "render": function (data, type, full, meta) { return meta.row + 1; } },
                                { "data": "Id", "name": "Id", "render": function (data, type, full, meta) { return meta.row + 1; } },
                                { "data": "StartDate", "name": "StartDate" },
                                { "data": "EndDate", "name": "EndDate" },
                                { "data": "Waktu", "name": "Waktu" },
                                {
                                    "render": function (data, type, full, meta) {
                                        return "<button type='button' id='btnEditDtl' class='btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-primary waves-effect waves-light' style='margin-right: 5px;' onclick='edit_pengajuandtl(" + meta.row + ")'><i class='fas fa-edit'></i></button>" + "  " +
                                               "<button type='button' id='btnDeleteDtl' class='btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-danger waves-effect waves-light' onclick='delete_pengajuandtl(" + meta.row + ")'><i class='fa fa-trash-alt'></i></button>";
                                  }
                                }
                            ]
                        });
                    });
                }
            }
        }

        function loadDataDetail(destination) {
            destination == "Detail" ? $("#btnAddDtl").hide() : $("#btnAddDtl").show();
            destination == "Detail" ? $("#btnSubmitData").hide() : $("#btnSubmitData").show();
            $('.nav-tabs a[href="#custom-tabs-two-detail"]').click(function () {
                loadDataDetailTable(destination);
            });
        }

        function getDataJenisCutiById(rowId) {
            $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Action("GetDataByID", "MasterJenisPengajuan")',
                type: 'POST',
                data: JSON.stringify({ "id": rowId}),
                success: function (data) {
                    if (data.metaData.code == '200') {
                        $("#JenisCuti").empty().append($("<option/>").val(data.response[0].id_jenis_pengajuan).text(data.response[0].nama_pengajuan)).val(data.response[0].id_jenis_pengajuan);
                    } else {
                        var s = "<option value='-1'></option>";
                        $("#CutiBulanan").html(s);
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    toastr.error('Gagal memuat data', 'Failed!', { "timeOut": 5000 });
                }
            });
        }

        function setTanggalPengajuan() {
            var today = new Date();
            var month = today.getMonth() + 1;
            var day = today.getDate();
            var currentDate = (('' + month).length < 2 ? '0' : '') + month +
                            '-' + (('' + day).length < 2 ? '0' : '') + day +
                            '-' + today.getFullYear();
            tglPengajuan = currentDate;
        }

        function show_modal_insertupdatedetail(action) {
            save_method = action;
            if (action == 'ADD') {
                document.getElementById("form-insertupdatedetail").reset();
                $("#insertUpdateDetailModal").text("Tambah Tanggal Cuti");
            } else if (action == 'EDIT') {
                $("#insertUpdateDetailModal").text("Ubah Tanggal Cuti");
            }
            $('.form-group').removeClass('has-error');
            $(".help-block").empty();
            $("#modal_form_insertupdatedetail").modal('show');
        }

        function matchStart(params, data) {
            // If there are no search terms, return all of the data
            if ($.trim(params.term) === '') {
                return data;
            }

            // Skip if there is no 'children' property
            if (typeof data.children === 'undefined') {
                return null;
            }

            // `data.children` contains the actual options that we are matching against
            var filteredChildren = [];
            $.each(data.children, function (idx, child) {
                if (child.text.toUpperCase().indexOf(params.term.toUpperCase()) == 0) {
                    filteredChildren.push(child);
                }
            });

            // If we matched any of the timezone group's children, then set the matched children on the group
            // and return the group object
            if (filteredChildren.length) {
                var modifiedData = $.extend({}, data, true);
                modifiedData.children = filteredChildren;

                // You can return modified objects from here
                // This includes matching the `children` how you want in nested data sets
                return modifiedData;
            }

            // Return `null` if the term should not be displayed
            return null;
        }
        function unselect_select2() {
            var newOption = new Option("", "", true, true);
            var newOption2 = new Option("", "", true, true);
            // Append it to the select
            $('#JenisCuti').append(newOption).trigger('change');
            $('#IDApproval').append(newOption2).trigger('change');

        }
        function loadDataSelect2() {
            var idApproval = "";
            var listDetailPct = [];


            $.ajax({
                url: '@Url.Action("GetDatatableAll", "MasterJenisPengajuan")',
                type: 'POST',
                dataType: 'json',
                delay: 250,
                processResults: function (data) {
                    return {
                        results: $.map(data['data'], function (item) {
                            if (!item.id_jenis_pengajuan.toUpperCase().includes('DL')) {
                                return {
                                    text: item.nama_pengajuan,
                                    id: item.id_jenis_pengajuan
                                }
                            }
                        })
                    };
                }
            }).then(
                function (response) {
                    $('#JenisCuti').select2({
                        multiple: false,
                        allowClear: true,
                        placeholder: '- Pilih Jenis Cuti -',
                        width: '100%',
                        theme: 'bootstrap4',
                        data: $.map(response.data, function (item) {
                            if (!item.id_jenis_pengajuan.toUpperCase().includes('DL')) {
                                return {
                                    text: item.nama_pengajuan,
                                    id: item.id_jenis_pengajuan
                                }
                            }
                        })
                    });
                }
            );

            $.ajax({
                url: '@Url.Action("GetDatatableAll", "MasterApproval")',
                type: 'POST',
                dataType: 'json',
                delay: 250,
                processResults: function (data) {
                    return {
                        results: $.map(data['data'], function (item) {
                            if (GroupID.toUpperCase().includes('STAFF')) {
                                if (!item.id_approval.toUpperCase().includes('HRD')) {
                                    if (item.status == "Aktif") {
                                        return {
                                            text: item.nama_approval,
                                            id: item.id_approval
                                        }
                                    }
                                }

                            } else {
                                if (item.status == "Aktif") {
                                    return {
                                        text: item.nama_approval,
                                        id: item.id_approval
                                    }
                                }
                            }

                        })
                    };
                }
            }).then(
                function (response) {
                    $('#IDApproval').select2({
                        multiple: false,
                        allowClear: true,
                        placeholder: '- Pilih ID Approval -',
                        width: '100%',
                        theme: 'bootstrap4',
                        data: $.map(response.data, function (item) {
                            if (GroupID.toUpperCase().includes('STAFF')) {
                                if (!item.id_approval.toUpperCase().includes('HRD')) {
                                    if (item.status == "Aktif") {
                                        return {
                                            text: item.nama_approval,
                                            id: item.id_approval
                                        }
                                    }
                                }

                            } else {
                                if (item.status == "Aktif") {
                                    return {
                                        text: item.nama_approval,
                                        id: item.id_approval
                                    }
                                }
                            }
                        })
                    });
                }
            );

            $('#IDApproval').on('select2:select', function (e) {
                var idApproval = {
                    "id": $("#IDApproval option:selected").val()
                };
                $('#IDKywApproval').empty();
                $.ajax({
                    contentType: 'application/JSON; charset=utf-8',
                    url: '@Url.Action("GetDataByIdApproval", "MasterKaryawanApproval")',
                    data: JSON.stringify(idApproval),
                    type: 'POST',
                    dataType: 'json',
                    delay: 250,
                    processResults: function (data) {
                        return {
                            results: $.map(data['data'], function (item) {
                                return {
                                    text: item.nama,
                                    id: item.id_karyawan,
                                    data: item
                                }
                            })
                        };
                    }
                }).then(
                    function (response) {
                        $('#IDKywApproval').select2({
                            multiple: false,
                            allowClear: true,
                            placeholder: '- Pilih ID Karyawan Approval -',
                            width: '100%',
                            theme: 'bootstrap4',
                            data: $.map(response.data, function (item) {
                                    return {
                                        text: item.nama,
                                        id: item.id_karyawan,
                                        data: item
                                    }
                            })
                        });
                    }
                );

                var newOption = new Option("", "", true, true);
                $('#IDKywApproval').append(newOption).trigger('change');
            });

            $('#IDKywApproval').select2({
                multiple: false,
                allowClear: true,
                placeholder: '- Pilih ID Karyawan Approval -',
                width: '100%',
                theme: 'bootstrap4',
            });
            $('#IDApproval').select2({
                multiple: false,
                allowClear: true,
                placeholder: '- Pilih ID Approval -',
                width: '100%',
                theme: 'bootstrap4',
            });


            $('#IDApproval').on('select2:unselect', function () {
                $('#IDKywApproval').empty();
                $('#IDKywApproval').select2({
                    multiple: false,
                    allowClear: true,
                    placeholder: '- Pilih ID Karyawan Approval -',
                    width: '100%',
                    theme: 'bootstrap4',
                    data: null
                });
            })

            //$(document).ready(function () {
                $('#datepicker').datepicker({
                    multidate: true,
                    format: "mm/dd/yyyy",
                    todayHighlight: true,
                    beforeShowDay: function () {
                        return true;
                    }
                }).on('changeDate', function (e) {
                    listDateCollection = $("#LeaveDatePicker").val().split(",");
                    $("#totalDurasiInput").val($("#JenisCuti").val() != "CT_05" ? listDateCollection.filter(item => item).length + " hari" : listDateCollection.filter(item => item).length * 0.5 + " hari");
                });
            //});

            $("#datepicker").datepicker('setDates', null);
            $('#datepicker').datepicker('setStartDate', new Date());
        }

        function delete_pengajuandtl(rowId) {
            if (rowId != null) {
                Swal.fire({
                    title: 'Konfirmasi',
                    text: "Apakah Anda yakin akan menghapus data ini?",
                    type: 'warning',
                    showCancelButton: true,
                    confirmButtonColor: '#3085d6',
                    cancelButtonColor: '#d33',
                    confirmButtonText: 'Hapus Data',
                    confirmButtonClass: 'btn btn-primary',
                    cancelButtonClass: 'btn btn-danger ml-1',
                    buttonsStyling: false,
                    allowOutsideClick: () => !Swal.isLoading()
                }).then((result) => {
                    if (result.value == true) {
                        listDataDtl.splice(rowId, 1);
                        masterPengajuanDetailTable.clear();
                        masterPengajuanDetailTable.rows.add(listDataDtl).draw();
                    }
                });
            }
        }

        function edit_pengajuandtl(rowId) {
            save_method = "EDIT";
            rowData = rowId;
            $('.form-group').removeClass('has-error');
            $(".help-block").empty();

            if (rowId != null) {
                $("#StartDate").val(masterPengajuanDetailTable.row(rowId).data().start_date);
                $("#EndDate").val(masterPengajuanDetailTable.row(rowId).data().end_date);
                $("#Waktu").val(masterPengajuanDetailTable.row(rowId).data().durasi);

                $("#insertUpdateDetailModal").text("Ubah Tanggal Cuti");
                $("#modal_form_insertupdatedetail").modal('show');
            }
        }

        function add_update_data(save_method) {
            $(".form-group").removeClass('has-error');
            $(".help-block").empty();
            var validate = true;
            var sumDtlDuration = 0;
            $.each(listDataDtl, function () { return sumDtlDuration += parseFloat(this.durasi) || 0;});

            if ($("#JenisCuti").val() == "") {
                $('#spanJenisCuti').text('Jenis Cuti harus diisi');
                $('.err-jenisCuti').css('color: red');
                validate = false;
            }
            if ($("#Keterangan").val() == "" || !$("#Keterangan").val().replace(/\s/g, '').length) {
                //$('#Keterangan').parent().parent().parent().addClass('has-error');
                $('#Keterangan').next().text('Keterangan harus diisi');
                validate = false;
            }
            if ($("#AlmSaatCuti").val() == "" || !$("#AlmSaatCuti").val().replace(/\s/g, '').length) {
                //$('#AlmSaatCuti').parent().addClass('has-error');
                $('#AlmSaatCuti').next().text('Alamat Saat Cuti harus diisi');
                validate = false;
            }
            if ($("#TelpSaatCuti").val() == "" || !$("#TelpSaatCuti").val().replace(/\s/g, '').length) {
                //$('#TelpSaatCuti').parent().addClass('has-error');
                $('#TelpSaatCuti').next().text('No. Telp. Saat Cuti harus diisi');
                validate = false;
            }
            if ($("#IDApproval").val() == "") {
                $('#spanIdApproval').text('ID Approval harus diisi');
                $('.err-idApproval').css('color: red');
                validate = false;
            }
            if ($("#IDKywApproval").val() == "") {
                $('#spanIdKywApproval').text('ID Karyawan Approval harus diisi');
                $('.err-idKywApproval').css('color: red');
                validate = false;
            }
            if ($("#totalDurasiInput").val() == "0 hari") {
                $('#span_tanggal').text('Tanggal Cuti Harus diisi');
                validate = false;
            }

            if (!listDateCollection.length) {
                $('#span_tanggal').text('Tanggal Cuti Harus diisi');
                toastr.warning("Anda belum memilih Tanggal Cuti.", "Sorry!", { "timeOut" : 5000});
                validate = false;
            }
            if ((parseFloat($("#LamaCuti").val()) || 0) != sumDtlDuration) {
                toastr.warning("Total Durasi di Detail harus sama dengan Lama Cuti", "Sorry!", { "timeOut": 5000 });
                validate = false;
            }
            if ($("#file").val() != "") {
                validate = checkfile();
            }

            if (!validate) return;

            var durasi = $("#JenisCuti").val() == "CT_05" ? 0.5 : 1;
            var totalDurasi = listDateCollection.length * durasi;
            var submittedData = {
                "tgl_pengajuan": tglPengajuan,
                "id_karyawan" : tempId,
                "id_jenis_pengajuan" : $("#JenisCuti").val(),
                "durasi": totalDurasi,
                "alamat_cuti" : $("#AlmSaatCuti").val(),
                "notelp_cuti" : $("#TelpSaatCuti").val(),
                "keterangan_pengajuan" : $("#Keterangan").val(),
                "approve_status": "PENDING",
                "created_by" : tempId,
                "created_date" : new Date(),
                "id_approval" : $("#IDApproval").val(),
                "approved_by" : $("#IDKywApproval").val(),
                "details" : []
            };

            for (var i = 0; i < listDateCollection.length; i++) {
                var date = listDateCollection[i].split("/");
                submittedData.details.push({
                    "id_pengajuan": "0",
                    "id_pengajuan_detail": i.toString(),
                    "start_date": new Date(date[0] + "-" + date[1] + "-" + date[2]),
                    "end_date": new Date(date[0] + "-" + date[1] + "-" + date[2]),
                    "durasi": durasi
                });
            }

            if (save_method == 'ADD') {
                url = '@Url.Action("CreateNewPengajuanCuti", "PengajuanCuti")'; //+ submittedData;
                form = "form-insertupdate";
            }
            else if (save_method == 'UPDATE') {
                url = "@Url.Content("~/MasterMenu/UpdateMenu")";
                form = "form-insertupdate";
                var g = masterPengajuanDetailTable.rows().data();
            }

            $.ajax({
                url: '@Url.Content("~/PengajuanCuti/CreateNewPengajuanCuti")',
                contentType: 'application/JSON; charset=utf-8',
                type: 'POST',
                dataType: 'json',
                data: JSON.stringify(submittedData),
                beforeSend: function () {
                    Swal.fire({
                        title: 'Processing...',
                        html: "Saving Data.",
                        allowOutsideClick: false,
                        onBeforeOpen: () => {
                            Swal.showLoading()
                        }
                    });
                },
                success: function (data) {
                    //Swal.close(); // add setelah upload file
                    if (data.response.Code == "200") {
                        id_Pengajuan = data["data"];
                        //console.log(id_Pengajuan);

                        if ($("#file").val() != "") {
                            //send File to Server
                            upload_file(id_Pengajuan);
                        } else {
                             toastr.success("Data Pengajuan Cuti dengan ID Pengajuan <strong>" + data["data"] + "</strong> berhasil diajukan", "Success!", { "timeOut": 5000 });
                            setTimeout(function () {
                                pengajuanCutiTable.ajax.reload(null, false);
                                $("#cardPengajuanHeader").show(100);
                                $("#cardPengajuanDetail").hide();
                            }, 1000);

                            Swal.close();
                        }
                    } else {
                        Swal.close();
                        toastr.warning(data.response.Message, "Sorry!", { "timeOut": 5000 });

                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    Swal.close();
                    $('#btnSaveAddUpdate').text('Save'); //change button text
                    $('#btnSaveAddUpdate').attr('disabled', false);
                    toastr.error("Gagal submit data pengajuan.", 'Failed!', { "timeOut": 5000 });
                }
            });
        }

        function validateDataDtl(item, rowData) {
            if (save_method == "ADD") {
                for (var i = 0; i < listDataDtl.length; i++) {
                    if (listDataDtl[i].start_date == item.start_date) return "Tanggal Mulai sudah ada";
                    if (listDataDtl[i].end_date == item.end_date) return "Tanggal Selesai sudah ada";
                }
            } else if (save_method == "EDIT") {
                for (var i = 0; i < listDataDtl.length; i++) {
                    if (i != rowData) {
                        if (listDataDtl[i].start_date == item.start_date) return "Tanggal Mulai sudah ada";
                        if (listDataDtl[i].end_date == item.end_date) return "Tanggal Selesai sudah ada";
                    }
                }
            }
            return "Success";
        }

        function add_update_detail() {
            var validate = "Success";
            var _validate = true;
            var itemDtl = {
                "start_date": $("#StartDate").val(),
                "end_date": $("#EndDate").val(),
                "durasi": $("#Waktu").val()
            };

            $('.form-group').removeClass('has-error');
            $(".help-block").empty();

            if ($("#StartDate").val() == "" || !$("#StartDate").val().replace(/\s/g, '').length) {
                //$('#StartDate').parent().addClass('has-error');
                $('#span_start_date').text('Tanggal Mulai harus diisi');
                _validate = false;
            }
            if ($("#EndDate").val() == "" || !$("#EndDate").val().replace(/\s/g, '').length) {
               // $('#EndDate').parent().addClass('has-error');
                $('#span_end_date').text('Tanggal Selesai harus diisi');
                _validate = false;
            }
            if ($("#Waktu").val() == "" || !$("#Waktu").val().replace(/\s/g, '').length) {
                //$('#Waktu').parent().addClass('has-error');
                $('#Waktu').next().text('Waktu harus diisi');
                _validate = false;
            }
            if ($("#file").val() != "" ) {
                _validate = checkfile();
            }
            if (!_validate) return;

            if (save_method == "ADD") {
                if (listDataDtl.length > 0) validate = validateDataDtl(itemDtl, 0);

                if (validate == "Success") {
                    listDataDtl.push(itemDtl);

                }
                else {
                    $("#modal_form_insertupdatedetail").modal('hide');
                    return toastr.warning("Gagal menambahkan data: " + validate, "Sorry!", { "timeOut": 5000 });
                }
            }
            else if (save_method == "EDIT") {
                if (listDataDtl.length > 0) validate = validateDataDtl(itemDtl, rowData);

                if (validate == "Success") {
                    listDataDtl[rowData].start_date = itemDtl.start_date;
                    listDataDtl[rowData].end_date = itemDtl.end_date;
                    listDataDtl[rowData].durasi = itemDtl.durasi;
                }
                else {
                    $("#modal_form_insertupdatedetail").modal('hide');
                    return toastr.warning("Gagal menambahkan data: " + validate, "Sorry!", { "timeOut": 5000 });
                }
            }

            masterPengajuanDetailTable.clear();
            masterPengajuanDetailTable.rows.add(listDataDtl).draw();
            $("#modal_form_insertupdatedetail").modal('hide');
        }

        function upload_file(id) {
            // Checking whether FormData is available in browser
            if (window.FormData !== undefined) {

                var fileData = new FormData($("#form-header").get(0));

                fileData.append("idPengajuan", id);

                $.ajax({
                   @* url: '@Url.Content("~/FileUpload/UploadFiles")',*@
                    url: '@Url.Action("UploadFiles", "FileUpload")',
                    type: "POST",
                    enctype : "multipart/form-data",
                    contentType: false, // Not to set any content header
                    processData: false, // Not to process data
                    data: fileData,
                    success: function (result) {
                       // alert("success");
                        Swal.close();
                        toastr.success("Data Pengajuan Cuti dengan ID Pengajuan <strong>" + id + "</strong> berhasil diajukan", "Success!", { "timeOut": 5000 });
                        setTimeout(function () {
                            pengajuanCutiTable.ajax.reload(null, false);
                            $("#cardPengajuanHeader").show(100);
                            $("#cardPengajuanDetail").hide();
                        }, 1000);
                    },
                    error: function (err) {
                        Swal.close();
                        alert(err.statusText);
                    }
                });
            } else {
                Swal.close();
                alert("FormData is not supported.");
            }
        }
        function RemoveFile() {
            
            $('#file').val('');
            $('#file').next('label').html('Pilih File');
            $("#spanfile").text("");
        }

        $("#cancelFile").click(function () {
            document.getElementById("file").value = "";
        })

        //get file size
        function GetFileSize(fileid) {
            try {
                  fileSize = 0;
               @* //for IE
                if ($.browser.msie) {
                    //before making an object of ActiveXObject,
                    //please make sure ActiveX is enabled in your IE browser
                    var objFSO = new ActiveXObject("Scripting.FileSystemObject"); var filePath = $("#" + fileid)[0].value;
                    var objFile = objFSO.getFile(filePath);
                    var fileSize = objFile.size; //size in kb
                    fileSize = fileSize / 1048576; //size in mb
                }
                //for FF, Safari, Opeara and Others
                else {
                    fileSize = $("#" + fileid)[0].files[0].size //size in kb
                    fileSize = fileSize / 1048576; //size in mb
                }*@
                fileSize = $("#" + fileid)[0].files[0].size //size in kb
                fileSize = fileSize / 1048576; //size in mb

                return fileSize;
            }
            catch (e) {
                //alert("Error is :" + e);
            }
        }

        //get file path from client system
        function getNameFromPath(strFilepath) {
            var objRE = new RegExp(/([^\/\\]+)$/);
            var strName = objRE.exec(strFilepath);

            if (strName == null) {
                return null;
            }
            else {
                return strName[0];
            }
        }


        function checkfile() {
            var file = getNameFromPath($("#file").val());
            if (file != null) {
                var extension = file.substr((file.lastIndexOf('.') + 1));
                switch (extension) {
                   @* case 'doc':
                    case 'docx':*@
                    case 'pdf':
                        flag = true;
                        break;
                    default:
                        flag = false;
                }
            }
            if (flag == false) {
                $("#spanfile").text("You can upload only pdf extension file");
                return false;
            }
            else {
                var size = GetFileSize('file');
                if (size > 2) {
                    $("#spanfile").text("You can upload file up to 2 MB");
                    return false;
                }
                else {
                    $("#spanfile").text("");
                    return true;
                    
                }
            }
        }
        $('#btn-file-reset-id').on('click', function () {
           
        });

        function saveFile() {
            window.open("https://116.254.101.104/CutiInta/"+ detailLinkFile, '_blank');
        }
    </script>
}
